
// place your rules here or add more .js files in this directory
log("add your rules to /etc/wb-rules/");

var beforeChangeDirTimeout = 600;
var afterChangeDirectionTimeout = 50;
var afterOnTimeout = 60000;

function makeShutter(name, upCtrl, downCtrl, r10r_num, r10r_ch) {

    defineVirtualDevice(name, {
        title: name,
        cells: {
            state: {
                title: "currentstate",
                type: "text",
                value: "STOPPED"
            },
            newState: {
                title: "newstate",
                type: "text",
                value: ""
            },
        }
    });
	
	var onCtrl = "wb-gpio/" + r10r_num + "_ON" + r10r_ch;
	var dirCtrl = "wb-gpio/" + r10r_num + "_DIR" + r10r_ch;

    var switchState_timer_id = null;
    defineRule(name + "_switcher", {
        whenChanged: [].concat(upCtrl, downCtrl),
        then: function (newValue, devName, cellName) {
            log("devName:{}, cellName:{}, newValue:{}", devName, cellName, newValue);
            if (newValue) {
                log("New value true");
                if (switchState_timer_id) {
                    clearTimeout(switchState_timer_id);
                }
                dev[onCtrl] = false;
                log(devName + "/" + cellName)
                if (upCtrl.indexOf(devName + "/" + cellName) !== -1) {
                    dev[name + "/newState"] = "UP";
                    log["New state up"];
                } else {
                    dev[name + "/newState"] = "DOWN";
                    log["New state down"];
                }
                switchState_timer_id = setTimeout(function () {
                    if (dev[name + "/newState"] === dev[name + "/state"]) {
                        log("new state is current state");
                        dev[name + "/state"] = "STOPPED";
                        dev[name + "/newState"] = "";
                        switchState_timer_id = null;
                    } else {
                        if (dev[name + "/newState"] === "UP") {
                            log("new state is up, change direction");
                            dev[dirCtrl] = true;
                            dev[name + "/state"] = "UP";
                        } else {
                            log("new state is down, change direction");
                            dev[dirCtrl] = false;
                            dev[name + "/state"] = "DOWN";
                        }
                        switchState_timer_id = setTimeout(function () {
                            log("turn on");
                            dev[onCtrl] = true;
                            switchState_timer_id = setTimeout(function () {
                                log("switch off");
                                dev[onCtrl] = false;
                                dev[name + "/state"] = "STOPPED";
                                switchState_timer_id = null;
                            }, afterOnTimeout);
                        }, afterChangeDirectionTimeout);
                    }
                    log("new state is processed empty it");
                    dev[name + "/newState"] = "";
                }, beforeChangeDirTimeout);
            }
        }
    });
}


makeShutter("R0.02.01", ["wb-gpio/EXT1_IN1"], ["wb-gpio/EXT1_IN2"], "EXT3", "1");
makeShutter("R0.01.04", ["wb-gpio/EXT1_IN3"], ["wb-gpio/EXT1_IN4"], "EXT3", "2");
makeShutter("R0.01.03", ["wb-gpio/EXT1_IN5"], ["wb-gpio/EXT1_IN6"], "EXT3", "3");
makeShutter("R0.01.02", ["wb-gpio/EXT1_IN7"], ["wb-gpio/EXT1_IN8"], "EXT3", "4");

makeShutter("R0.01.01", ["wb-gpio/EXT1_IN9"], ["wb-gpio/EXT1_IN10"], "EXT4", "1");
makeShutter("R0.04.01", ["wb-gpio/EXT1_IN11"], ["wb-gpio/EXT1_IN12"], "EXT4", "2");

makeShutter("R1.03.01", ["wb-gpio/EXT2_IN1"], ["wb-gpio/EXT2_IN2"], "EXT5", "1");
makeShutter("R1.02.01", ["wb-gpio/EXT2_IN3"], ["wb-gpio/EXT2_IN4"], "EXT5", "2");
makeShutter("R1.05.01", ["wb-gpio/EXT2_IN5"], ["wb-gpio/EXT2_IN6"], "EXT5", "3");

